package test.web;


import javax.annotation.Resource;
import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.jws.WebMethod;
import javax.jws.WebService;


/**
 * Session Bean implementation class NorthBoundWebService
 */
@Stateless
@LocalBean
@WebService(serviceName = "NBService", portName = "NBServiceAT", name = "NBServiceAT", targetNamespace = "http://www.jboss.com/jbossas/quickstarts/wsat/simple/nb")
public class NorthBoundWebService {

	@Resource(name = "java:/ConnectionFactory")
	private ConnectionFactory connectionFactory;

	@Resource(name = "java:/queue/delegateQueue")
	private Queue queue;


	@WebMethod
	public void receiveRequest() {
		Connection connection = null;
		try {
			connection = connectionFactory.createConnection();
			Session session = connection.createSession(false,
					Session.AUTO_ACKNOWLEDGE);
			MessageProducer messageProducer = session.createProducer(queue);
			connection.start();
			TextMessage message = session.createTextMessage();
			for (int i = 0; i < 100; i++) {
				message.setStringProperty("name", "F" + ((i%5) + 1));
				message.setText("This is message " + ((i%5) + 1));
				messageProducer.send(message);
			}
		} catch (Throwable t) {
			t.printStackTrace();
		} finally {
			if (connection != null) {
				try {
					connection.close();
				} catch (JMSException e) {
					e.printStackTrace();
				}
			}
		}
		System.out.println("Completing web service call.");
	}
}
